%NA-plot:

%Bane eller strekning?
%Et plott eller mange?
%Plot noe opp noe annet.
%Hvordan m datasettet se ut? Trenger i hvert fall kovariatene.

%gammavektor = resultater fra analysen


%Lag ei matrise med infoen du trenger:
Dataset = importfileVaska('DatasetTilMatlabVaska180513.csv',2,8433);
% DatasetFeilInfo = import FeiltidtilNA.csv
DatasetFeilinfo = importfileFeilInfo('FeiltidTilNAPlot190513.csv', 2, 4126);
%%
%Flytt daginnlagt til 0, dag tatt ut til (2013-1900)*365. Hold hele tiden
%oversikt over ontest. OG! ontest m ta hensyn til lengde. Det er antall
%meter on test som er interressant
%,'1301' tatt ut
%strekning = {'1350','1341','1340','1330','1321','1320','1310','1300','1200','1600','1650','1660','2000','2120','2130','2220','0700','0710','0720','0721','1100','1110','1111','1120','0900','0910','0920','1000','1010','1011','1680','2301','2310','2311','2312','2320','2330','2340','0540','0550','0560','0570','1510','0610','0620','0630','0640','0300','0310','0800','1400','1410','1420'};
strekning = {'0540', '1000', '0720', '2311'};
%strekning = {'0700','0710','0720','0721','1100','1110','1111','1120'}; %Dovrebanen!

DatasetLokasjonFeil = DatasetFeilinfo.Lokasjon;
DatasetLokasjon = Dataset.Lokasjon;
%baner = unique(DatasetFeilinfo(:,1));
f = figure(1);
    set(f,'name','Fire strekninger, estimert potenslov-intensitet og Nelson-estimator','numbertitle','off');
    for j=1:length(strekning) %length(strekning)
    clear A0 lengdeontest NAnevner NAteller vlengdeontest ObjektdsNA FeildsNA
    
    %Setter frst opp datasettene ObjektdsNA og FeildsNA:
    
    %For baner:
%     ObjektdsNA =  Dataset(datasetStrFind(Dataset,char(baner.Bane(j)),3),[4,10,11,12]);
%     FeildsNA = DatasetFeilinfo(datasetStrFind(DatasetFeilinfo,char(baner.Bane(j)),1),[2,4,5,6]); % [bane, strekning, objekt, Dagoppstatt; DagInnlagt, tijD, (kovariater)];

    %For strekning:
    ObjektdsNA =  Dataset(datasetStrFind(dataset(strtok(DatasetLokasjon,'-')),char(strekning(j)),1),[4,10,11,12]); % [lokasjon lengde, aiD, biD, (kovariater)];
    FeildsNA = DatasetFeilinfo(datasetStrFind(dataset(strtok(DatasetLokasjonFeil,'-')),char(strekning(j)),1),[2,4,5,6]); % [bane, strekning, objekt, Dagoppstatt; DagInnlagt, tijD, (kovariater)];

    %Kjrer s gjennom NA-estimatoren.
    ObjektdsNA.aiD = (ObjektdsNA.aiD > 0).*ObjektdsNA.aiD; %setter aiD til null hvis den er negativ.
    A0(1) = 0;
    for i=1:max(ObjektdsNA.biD)

        lengdeontest = sum((ObjektdsNA.aiD < i & ObjektdsNA.biD > i).*ObjektdsNA.Lengde)*1000; %Hvor mange meter skinne er observert denne dagen? Br den her skaleres etter banelengde? 
        NAnevner = lengdeontest; 
        NAteller = sum(FeildsNA.tijD == i); %Hvor mange feil er observert denne dagen?
        if NAteller > 0
            A0(i+1) = A0(i) + NAteller/NAnevner; %ZNA ker kumulativt hvis det skjedde en feil p dagen i
        else
            A0(i+1) = A0(i); %ZNA endrer seg ikke hvis det ikke skjedde en feil.
        end
    end
    
    t = 0:max(ObjektdsNA.biD);
    subplot(2,2,j)
    figure(j)
    plot(t,A0,'color','blue'); %Plot dritten.
    lambdahatNA = parametereStrekning.Lambdahat(j);
    betahatNA = parametereStrekning.Betahat(j);
    hold on
    plot(t,lambdahatNA.*t.^betahatNA,'color','red')
    
    lambdahatNA = parametereStrekning.maxalpha(j);
    betahatNA = parametereStrekning.min_beta(j);
    plot(t,lambdahatNA.*t.^betahatNA,'color','g')
    
    lambdahatNA = parametereStrekning.minalpha(j);
    betahatNA = parametereStrekning.max_beta(j);
    plot(t,lambdahatNA.*t.^betahatNA,'color','m')
    grid    
    xlabel('t = Antall dager siden frste skinne ble satt i drift [d]','FontSize',14);
    ylabel('Antall feil per dag per meter skinne i drift','FontSize',14);
    tittel = 'Strekning: ';
    title(strcat(tittel,char(strekning(j))),'FontSize',20);
    legend('Nelson-estimator for kumulativt antall feil','Estimert kumulativ feilfrekvens etter potenslov-modellen', 'FontSize', 14, 'location', 'NorthWest');

    hold off 
    j
end
saveas(f,char(strekning(j)),'fig');

  

%%
betahat = vparamhat(1);
lambdahat = vparamhat(2);
t = 0:max(ObjektdsNA.biD);
Wmle = lambdahat.*t.^betahat;
hold on
%%
hold off
plot(0:max(ObjektdsNA.biD),A0)
hold on
plot(t,Wmle)
hold on
plot(t,lambdahat.*t.^vbetamin)
hold on
plot(t,lambdahat.*t.^vbetamax)
%%Duane-plot: 
%Br g greit med samme data som til NAPlotet. Ta det senere.
%t/N(t) plotta mot t p log-log-papir. Rett linje: Power law.
%For ett system. Alts en strekning eller en bane.
%%
%%Likelihood ratio test statistic
% H0:Hpp
% H1:not HPP
DatasetLokasjonFeil = DatasetFeilinfo.Lokasjon;
clear Hi pvalue
dof = 0;
for j=1:length(strekning)
    clear aiLT biLT TijLT Hi
%     For baner
%     FeildsNA = DatasetFeilinfo(datasetStrFind(DatasetFeilinfo,char(baner.Bane(j)),1),[2,4,5,6]);
%     For strekning
    FeildsNA = DatasetFeilinfo(datasetStrFind(dataset(strtok(DatasetLokasjonFeil,'-')),char(strekning(j)),1),[2,4,5,6]);
    Hi = 0;
    for i = 1:(length(FeildsNA))
        aiLT = 103*365 - FeildsNA.DagInnlagt(i);
        aiLT = (aiLT > 0)*aiLT;           %setter aiLT til null hvis den er negativ.
        biLT = 113*365 - FeildsNA.DagInnlagt(i);
        TijLT = double(FeildsNA.DagOppstatt(i)) - double(FeildsNA.DagInnlagt(i));

        Hi = Hi + 2*log((biLT - aiLT)/(TijLT - aiLT));
        
    end
    vhi(j) = Hi;
    IFR(j) = chi2inv(0.9,(2*(length(FeildsNA))));
    DFR(j) = chi2inv(0.1,(2*(length(FeildsNA))));
    pvalue(j) = 1 - chi2cdf(Hi,(2*(length(FeildsNA))));
    if Hi > 0
    dof = dof + (2*(length(FeildsNA)-1));
    end
end
    a = [vhi;IFR;DFR;pvalue];
    chi2total = chi2inv(0.80,dof);
    Hitotal = sum(vhi);
    ptotal = 1 - chi2cdf(Hitotal,dof);