
%DatasetULKontroll = importfileULKontroll('DatasetULKontroll280413.csv',2,8947);
%DatasetVaska = importfileVaska('DatasetVaska280413.csv',2,8775);

%Dataset = DatasetVaska;
%Dataset = DatasetULKontroll;

syms lambda beta fun

clear vlambdamin vlambdamax loglikei vlstrekning loglike dsstrekning dlambda dbeta lambdahatsym dbetainnsatt dbetainnsattfun betahat lambdahat ni li lnti bi ai k varbeta varlambda cov vi vlvalue vbetamin vbetamax vparamhat


%strekning = {'1350','1341','1340','1330','1321','1320','1310','1300','1200','1600','1650','1660','2000','2120','2130','2220','0700','0710','0720','0721','1100','1110','1111','1120','0900','0910','0920','1000','1010','1011','1680','2301','2310','2311','2312','2320','2330','2340','0540','0550','0560','0570','1510','0610','0620','0630','0640','0300','0310','0800','1400','1410','1420'};
strekning = {'0540', '1000', '0720', '2311'};
%strekning = {'0700','0710','0720','0721','1100','1110','1111','1120'}; %Dovrebanen!
%baner = {'Nordlandsbanen' , 'Hovedbanen', 'Askerbanen', 'Dovrebanen'};
DatasetLokasjon = Dataset.Lokasjon;
vni = zeros(1,length(strekning)); 
for j=1:length(strekning)
        clear loglikei loglike dsstrekning dlambda dbeta lambdahatsym dbetainnsatt dbetainnsattfun betahat lambdahat ni li lnti bi ai k a f
%         dsbane = Dataset(datasetStrFind(Dataset,char(strekning(j)),3),[5,10,9,11,12,6]); %#feil, lengde, lnti, ai, bi, AArInnlagt
%         DatasetLokasjon;
        dsstrekning =  Dataset(datasetStrFind(dataset(strtok(DatasetLokasjon,'-')),char(strekning(j)),1),[5,10,9,11,12,7]); %#feil, lengde, lnti, ai, bi, AArInnlagt
        Dataset(datasetStrFind(dataset(strtok(DatasetLokasjon,'-')),char(strekning(j)),1),[2,3,4]);
        sum(double(Dataset(datasetStrFind(dataset(strtok(DatasetLokasjon,'-')),char(strekning(j)),1),10)));
        k=1;
        loglike = 0;
        vlstrekning(j) = sum(double(dsstrekning(:,2)))*1000;
        j
        for i=1:length(dsstrekning)
            if double(dsstrekning(i,6)) > 0
                bi = double(dsstrekning(i,5));
                if bi > 0
                    ni = double(dsstrekning(i,1));
                    vni(j) = vni(j) + ni;
                    li = double(dsstrekning(i,2))*1000;%/lstrekning;
                    if li > 0
                        
                        if(double(dsstrekning(i,4))>0)
                            ai = double(dsstrekning(i,4));
                        else
                            ai = 0;
                        end
                        
                        if ni == 0
                            loglike = loglike - lambda * li*(bi^(beta) - ai^(beta));
                        else
                            lnti = double(dsstrekning(i,3));
                            loglike = loglike + ni*log(lambda) + ni*log(beta) + ni*log(li) + (beta -1)*lnti - lambda * li*(bi^(beta) - ai^(beta));
                        end
                    end
                end
            end 
        end
   
        if loglike ~= 0
            loglikeminus = -1*loglike;
            loglikefun = matlabFunction(loglikeminus);
            loglikefunGate = @(X)loglikefun(X(1),X(2));
            options = optimset('MaxIter',20000,'MaxFunEvals',30000);
            betaguess = 1;
            [paramhat,lvalue]=fminsearchbnd(loglikefunGate,[betaguess,0.1],[0,0],[8,2],options);
            vparamhat(:,j) = paramhat;
        else
            vparamhat(:,j) = [0,0];
        end
        vlvalue(j) = -lvalue;
        vi(j) = i;
        
        if vparamhat(2,j)>0
            
            varbetafun = matlabFunction(1/diff(loglikeminus,beta,2));
            varlambdafun = matlabFunction(1/diff(loglikeminus,lambda,2));
            covfun = matlabFunction(1/diff(diff(loglikeminus,beta,1),lambda,1));
            varbeta(j) = varbetafun(paramhat(1),paramhat(2));
            varlambda(j) = varlambdafun(paramhat(2));
            cov(j) = covfun(paramhat(1));
            %profile likelihood for beta, given lambdahat(beta) gives a 95% CI
            %for beta:


            lambdahatbeta = solve(diff(loglike,beta) == 0, lambda);
            profilebetafun = matlabFunction(- subs(loglike,lambda,lambdahatbeta));
            CIvaluebeta = profilebetafun(paramhat(1)) + 1.92/4;

            f = matlabFunction(- subs(loglike,lambda,lambdahatbeta)- CIvaluebeta);
            a = unique(fsolve(f,[abs(paramhat(1)-0.4),paramhat(1)+1]));
            vbetamin(j) = min(a);
            vbetamax(j) = max(a);
            
%             SDlnlambda = sqrt(varlambda(j))/paramhat(2);
%             SDlnbeta = sqrt(varbeta(j))/paramhat(1);
%             
%             vlambdamax(j) = paramhat(2)*exp(1.96*SDlnlambda);
%             vlambdamin(j) = paramhat(2)*exp(-1.96*SDlnlambda);
%             
%             vbetamin(j)=paramhat(1)*exp(1.96*SDlnbeta);
%             vbetamax(j)=paramhat(1)*exp(-1.96*SDlnbeta);

              vlambdamin(j) = paramhat(2)*exp(-1.00*log(vni(j))/sqrt(vni(j)));
              vlambdamax(j) = paramhat(2)*exp(1.00*log(vni(j))/sqrt(vni(j)));
        else
            vbetamin(j) = 0;
            vbetamat(j) = 0;
            varbeta(j) = 0;
            varlambda(j) = 0;
            cov(j) = 0;
        end
        

%         dlambda = diff(loglike, lambda);
%         dbeta = diff(loglike,beta);
%         lambdahatsym = solve(dlambda == 0, lambda);
%         
% 
%         dbetainnsatt = subs(dbeta,lambda,lambdahatsym);
%         dbetainnsattfun = @(beta) fun;
%         dbetainnsattfun = subs(dbetainnsattfun,fun,dbetainnsatt);
%         %ezplot(dbetainnsatt);
%         %axis([0,5,-500,500]);
%         %grid;
%         dbetainnsattfun = matlabFunction(dbetainnsatt);
%         betahat = fsolve(dbetainnsattfun,1);
%         vbetahat(j) = betahat;
%         lambdahat = double(subs(lambdahatsym,beta,betahat));
%         vlambdahat(j) = lambdahat;
    j
end
%%
clear snittalder
for j = 1:length(strekning)
    snittalder(j) = mean(double(Dataset(datasetStrFind(Dataset,char(strekning(j)),3),6)));
end



parametereStrekning = dataset(strekning',vlstrekning', vparamhat(1,:)',vparamhat(2,:)',vlvalue',vlambdamin',vbetamin',vlambdamax',vbetamax',varbeta',varlambda',cov',vi',vni',snittalder','VarNames',{'Strekning','lengde','Betahat','Lambdahat' ,'loglikeFval','minalpha','min.beta','maxalpha','max.beta','var(beta)','var(lambda)','cov(lambda,beta)','Antall objekter','Antall feil','snittalder'});