%% Alle baner med kovariater:

% for j=1:max(ObjektdsNA.biD) %length(strekning)



clear A0 lengdeontest NAnevner NAteller vlengdeontest ObjektdsNA FeildsNA


%strekning = {'1350','1341','1340','1330','1321','1320','1310','1300','1200','1600','1650','1660','2000','2120','2130','2220','0700','0710','0720','0721','1100','1110','1111','1120','0900','0910','0920','1000','1010','1011','1680','2301','2310','2311','2312','2320','2330','2340','0540','0550','0560','0570','1510','0610','0620','0630','0640','0300','0310','0800','1400','1410','1420'};
%strekning = {'1200'};
strekning = {'0700','0710','0720','0721','1100','1110','1111','1120'};
for j=1:length(strekning) %length(strekning)

    %Setter frst opp datasettene ObjektdsNA og FeildsNA:
    %For baner:
    % ObjektdsNA = Dataset(datasetStrFind(Dataset,char(baner.Bane(j)),3),[4,10,11,12]);
    % FeildsNA = DatasetFeilinfo(datasetStrFind(DatasetFeilinfo,char(baner.Bane(j)),1),[2,4,5,6]); % [bane, strekning, objekt, Dagoppstatt; DagInnlagt, tijD, (kovariater)];
    %For strekning:
    ObjektdsNA = Dataset(datasetStrFind(dataset(strtok(DatasetLokasjon,'-')),char(strekning(j)),1),[1,4,10,11,12,15,16,17,18,19]); % [lokasjon lengde, aiD, biD, (kovariater)];
    FeildsNA = DatasetFeilinfo(datasetStrFind(dataset(strtok(DatasetLokasjonFeil,'-')),char(strekning(1)),1),[2,4,5,6]); % [bane, strekning, objekt, Dagoppstatt; DagInnlagt, tijD, (kovariater)];
    %Kjrer s gjennom NA-estimatoren.

    ObjektdsNA.aiD = (ObjektdsNA.aiD > 0).*ObjektdsNA.aiD;

    %setter aiD til null hvis den er negativ.

    A0 = [0:max(ObjektdsNA.biD)];
    gamma = zeros(10,1);
    tunique = unique([ObjektdsNA.biD;ObjektdsNA.aiD]);

    tnext = 0;

    p = 1;

    for i=1:max(ObjektdsNA.biD)

        if FeildsNA.tijD(FeildsNA.tijD==i) >= 1

            if i >= tnext

                NAnevner = 0;

                objekterontest = ObjektdsNA.Objekt([find(ObjektdsNA.aiD < i & ObjektdsNA.biD > i)']);

                for k=1:length(objekterontest)

                    objekti = Dataset(datasetStrFind(Dataset, char(objekterontest(k)),1),:);

                    zi = FindCov(char(ObjektdsNA.Skinneprofil(k)), char(ObjektdsNA.Stlkvalitet(k)), ObjektdsNA.ValseAAr(k), char(ObjektdsNA.Nybrukt(k)))';

                    % zi=zeros(15,1);

                    NAnevner = NAnevner + objekti.Lengde.*exp(zi*gamma)*1000;

                    %Hvor mange meter skinne er observert denne dagen? Br den her skaleres etter banelengde?

                end

                p=p+1;

                tnext = tunique(p);

            end
            NAteller = sum(FeildsNA.tijD == i);
            %Hvor mange feil er observert denne dagen?
            A0(i+1) = A0(i) + NAteller/NAnevner;
            %ZNA ker kumulativt hvis det skjedde en feil p dagen i
        else
            A0(i+1) = A0(i);
        end

    end
end